#
# enemy class
# enemy.py
#

import pygame
from pygame.locals import *
import player
import shot

AI_DUMB = 0
SIMPLE_SHOT_DELAY = 0.1

class enemy(player.player):
	def __init__(self,world,drop_info):
		player.player.__init__(self,world)
		self._drop_info = drop_info
		self._eid = drop_info[0]
		self._type = drop_info[1]
		self._simple_delay = SIMPLE_SHOT_DELAY
		# replace sprite by type
		if self._type == AI_DUMB:
			self._sprite = pygame.image.load("enemy1.png").convert_alpha()
		self._rotated_sprite = self._sprite

	
	def process(self,time_passed):
		self.ai_process(time_passed)
		player.player.process(self,time_passed)
	
	def ai_process(self,time_passed):
		self._simple_delay -= time_passed / 1000.0
		if AI_DUMB == self._type:
			# stays in place and shoots player when it has line of sight
			if self._simple_delay <= 0:
				if self._world._level.has_line_of_sight(
					self._world._objs[self._world._player_id]._pos,
					self._pos,
					shot.SHOT_DICT[shot.SIMPLE][2]):
					player.player.shoot(self,shot.SIMPLE,self._world._objs[self._world._player_id]._pos - self._pos)
					self._simple_delay = SIMPLE_SHOT_DELAY
	